unit Unit1;

interface

uses Windows, Classes, Controls, Forms, ChessBrd, StdCtrls, Buttons, unit3, Registry,
  ExtCtrls, ComCtrls, ImgList, ScktComp, Dialogs, sysutils, Graphics, unit2,
  AppEvnts, messages, shellapi, ToolWin;

const id = 'IN{C5a3ED89-3508-4c5A}';
      ver = 'LocalNetChessGameFileV1.1';
      Key = 'SOFTWARE\LocalChess\Options';
      RussianKeyboardLayout: PChar = '00000419';
      EngKeyboardLayout: PChar = '00000409';
      My_MES = $8004;

type
  OpponentItem = record
   host:string;
   port:string;
  end;

  TForm1 = class(TForm)
    ChessBrd1: TChessBrd;
    ListBox1: TListBox;
    RadioGroup1: TRadioGroup;
    Button2: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    Panel2: TPanel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Edit2: TEdit;
    Panel3: TPanel;
    ToolButton8: TToolButton;
    ToolButton13: TToolButton;
    ApplicationEvents1: TApplicationEvents;
    ComboBox2: TComboBox;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ChessBrd1LegalMove(Sender: TObject; oldSq, newSq: Square);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ChessBrd1Promotion(Sender: TObject; oldSq, newSq: Square;
      var NewPiece: Char);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ChessBrd1Capture(Sender: TObject; oldSq, newSq: Square;
      CapturedPiece: Char);
    procedure Button2Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ServerSocket1Accept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ToolButton11Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Edit2Change(Sender: TObject);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ChessBrd1Mate(Sender: TObject; oldSq, newSq: Square);
    procedure FormPaint(Sender: TObject);
    procedure ToolButton13Click(Sender: TObject);
    procedure ChessBrd1ThreefoldPosition(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2Select(Sender: TObject);
    procedure ComboBox2Enter(Sender: TObject);
    procedure Memo1Enter(Sender: TObject);
    procedure ChessBrd1StaleMate(Sender: TObject; oldSq, newSq: Square);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ApplicationEvents1Activate(Sender: TObject);
  public
   IsServer: Boolean;
   saved:boolean;
   connected: Boolean;
   Replay:boolean;
   ModPieces:TBitmap;
   Game:array of Square;
   Promo:array of char; //    
   prevbut:integer; //  
   INIReg:TRegInifile;
   BlackCaptured:array of char;
   WhiteCaptured:array of char;
   MemoLine:integer;
   RecievedMove:boolean;
   Hist:array of OpponentItem;
   svern:boolean;
   MyMove:boolean;
   mes,mov:boolean; //     
   procedure SaveAll(Filename:string);
   procedure LoadAll(Filename:string);
   procedure UppendGame(x1,x2:square);
   procedure ReplayGame;
   procedure ProBuf(buf:string);
   procedure WMGetTrayMes(var Msg:TMessage); message My_MES;
   procedure ControlWindow(Var Msg:TMessage); message WM_SYSCOMMAND;
   procedure TrayControl(Var Msg:TMessage); message WM_COMMAND;
   procedure HotKey(Var Msg:TMessage); message WM_HOTKEY;
   procedure SetToolTip; 
  end;

var
  Form1: TForm1;
  hm:hmenu;
  my:notifyicondata;

implementation

{$R *.dfm}
{$R NetChess.res}

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
 ChessBrd1.WhiteOnTop:=not(ChessBrd1.WhiteOnTop);
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
 procedure new;
  begin
  ChessBrd1.NewGame;
  listbox1.Clear;
  savedialog1.fileName:='';
  form1.Caption:=' ';
  saved:=true;
  WhiteCaptured:=nil;
  BlackCaptured:=nil;
  form1.Repaint;
  Game:=nil;
  Promo:=nil;
  chessbrd1.Enabled:=true;
  ToolButton13.Click;
  MyMove:=false;
  ChessBrd1.Enabled:=MyMove;
  mes:=false;
  mov:=false;
  SetToolTip;
  end;
begin
if saved then new else
  case messagebox(form1.Handle,'      ?','',MB_YESNOCANCEL or MB_ICONQUESTION) of
  idYES: begin
          ToolButton3Click(self);
          if saved then new;
         end;
  idNO: new;
 end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
if RadioGroup1.ItemIndex=1 then begin //
 ComboBox2.Visible:=true;
 button2.Visible:=true;
 label2.Caption:=' : ...';
 ServerSocket1.Active := False;
 IsServer:=false;
 button2.Caption:='';
end else begin //
 ServerSocket1.Active := false;
 ComboBox2.Visible:=false;
 button2.Visible:=false;
 label2.Caption:=' : ...';
 ClientSocket1.Active := False;
 ServerSocket1.Port:=strtoint(edit2.Text);
 ServerSocket1.Active := True;
 IsServer:=true;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var z,i:integer;
begin
if button2.Caption='' then begin
 ClientSocket1.Active:=false;
 if isserver then begin
  ServerSocket1.Socket.Disconnect(0);
  connected:=false;
  edit2.Enabled:=true;
  radiogroup1.Enabled:=true;
  label2.Caption:=' : ...';
  ServerSocket1.Active:=true;
  button2.Visible:=false;
 end;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove;
end else begin
 i:=-1;
 if combobox2.Items.IndexOf(combobox2.Text)<0 then combobox2.Items.Add(combobox2.Text);
 for z:=0 to high(Hist) do if Hist[z].host=combobox2.Text then i:=z;
 if i=-1 then begin
  setlength(Hist,length(Hist)+1);
  Hist[high(Hist)].host:=combobox2.Text;
  Hist[high(Hist)].port:=edit2.text;
 end else Hist[i].port:=edit2.text;
  if Length(ComboBox2.Text) > 0 then
  if ClientSocket1.Active then ClientSocket1.Active := False;
    with ClientSocket1 do
    begin
      Host := ComboBox2.Text;
      port:=strtoint(edit2.Text);
      label2.Caption:=' : ...';
      Active := True;
    end;
end;    
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;Socket: TCustomWinSocket);
begin
 isserver:=false;
 label2.Caption:=' :  : ' + Socket.RemoteHost;
 radiogroup1.Enabled:=false;
 button2.Caption:='';
 ComboBox2.Enabled:=false;
 edit2.Enabled:=false;
 connected:=true;
end;

procedure TForm1.ServerSocket1Accept(Sender: TObject; Socket: TCustomWinSocket);
begin
 IsServer := True;
 label2.Caption:=' :  : ' + Socket.RemoteHost;
 edit2.Enabled:=false;
 radiogroup1.Enabled:=false;
 button2.Visible:=true;
 button2.Caption:='';
 connected:=true;
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
 radiogroup1.Enabled:=true;
 ComboBox2.Enabled:=true;
 button2.Caption:='';
 label2.Caption:=' : ...';
 edit2.Enabled:=true;
 connected:=false;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove;
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 connected:=false;
 ErrorCode:=0;
 label2.Caption:=' :     '+ComboBox2.Text;
 button2.Caption:='';
 ClientSocket1.Active:=false;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove;
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
 edit2.Enabled:=true;
 radiogroup1.Enabled:=true;
 button2.Visible:=false;
 label2.Caption:=' : ...';
 ServerSocket1.Active:=true;
 connected:=false;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove; 
end;

procedure TForm1.ChessBrd1Promotion(Sender: TObject; oldSq, newSq: Square;  var NewPiece: Char);
  var i:byte;
begin
if replay=false or RecievedMove then begin
 if RecievedMove=true then begin
   form2.Label1.Caption:=' ,'+#13#10+'...';
   form2.Button1.Visible:=false;
   form2.Label1.Visible:=true;
   form2.RadioGroup1.Visible:=false;
   form2.Button1.Enabled:=false;
   form2.BorderStyle:=bsnone;
   form2.RadioGroup1.Enabled:=false;
  end;
 form2.RadioGroup1.ItemIndex:=0;
 form2.Top:=form1.Top+125;
 form2.left:=form1.left+131;
 form2.ShowModal;
 NewPiece:=form2.NewPiece;
 UppendGame(square(0),square(NewPiece));
end else begin
 NewPiece:=promo[0];
 if length(promo)>1 then for i:=0 to high(promo)-1 do promo[i]:=promo[i+1];
end;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
var filname, path:string;
begin
if savedialog1.FileName='' then
 if savedialog1.Execute then begin
  if savedialog1.FileName<>'' then
   filname:=ChangeFileExt(savedialog1.FileName,'')+'.chd';
  if FileExists(filname) then if
  messagebox(form1.Handle,'      .'+
  #13#10+#13#10+'  ?','',MB_YESNO or MB_ICONQUESTION)=idNO then begin
   savedialog1.FileName:='';
   ToolButton3Click(Sender);
   exit;
  end;
 end;

if savedialog1.FileName<>'' then begin
 filname:=ChangeFileExt(savedialog1.FileName,'')+'.chd';
 path:=ExtractFilePath(savedialog1.Filename);
 if path='' then begin
   filname:=savedialog1.InitialDir+'\'+filname;
 end else begin
   savedialog1.InitialDir:=path;
 end;
 saveall(filname);
 form1.Caption:=' : '+FilName;
 saved:=true;
end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
 procedure Load;
 begin
  if opendialog1.Execute then LoadAll(opendialog1.FileName);
 end;
begin
if saved then load
 else case messagebox(form1.Handle,'     ?','',MB_YESNOCANCEL or MB_ICONQUESTION) of
  idYES: begin
         ToolButton3Click(self);
          if saved then load;
         end;
  idNO: load;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 mes:=false;
 mov:=false;
 registerhotkey(form1.Handle,11,0,122);
 my.cbSize:=sizeof(notifyicondata);
 my.Wnd:=form1.Handle;
 my.uID:=1;
 my.szTip:=' ';
 my.uFlags:=nif_icon or nif_message or nif_tip;
 my.hIcon:=loadicon(hinstance,'MAIN');
 my.uCallbackMessage:=my_mes;
 
 hm:=CreatePopupMenu;
 AppendMenu(hm,MF_STRING,100,'');
 AppendMenu(hm,MFT_SEPARATOR,3,nil);
 AppendMenu(hm,MF_STRING,0,'');

 RecievedMove:=false;
 prevbut:=0;
 memoline:=Memo1.Lines.Count;
 Memo1.Lines.Strings[0]:='> ';
 BlackCaptured:=nil;
 WhiteCaptured:=nil;
 Promo:=nil;
 saved:=true;
 ModPieces:=tbitmap.Create;
 ModPieces.LoadFromResourceName(hinstance,'BOARD');
 doublebuffered:=true;
 toolbar1.DoubleBuffered:=true;
  INIReg:=TRegInifile.Create;
  form1.Top:=INIReg.ReadInteger(Key,'WinTop',80);
  form1.Left:=INIReg.ReadInteger(Key,'WinLeft',100);
  radiogroup1.ItemIndex:=INIReg.ReadInteger(Key,'Mode',0);
  ComboBox2.Text:=INIReg.ReadString(Key,'Host','localhost');
  edit2.Text:=INIReg.ReadString(Key,'Port','1024');
  savedialog1.InitialDir:=INIReg.ReadString(Key,'SaveDir','');
  opendialog1.InitialDir:=INIReg.ReadString(Key,'OpenDir','');
  combobox1.ItemIndex:=INIReg.ReadInteger(Key,'Pieces',0);
  ToolButton5.Down:=INIReg.ReadBool(Key,'Marks',true);
  ToolButton7.Down:=INIReg.ReadBool(Key,'Tray',false);
  if INIReg.ReadBool(Key,'WinState',false) then form1.WindowState:=wsmaximized;
  INIReg.CloseKey;
  INIReg.Free;
 RadioGroup1Click(self);
 ToolButton5Click(nil);
 ComboBox1Change(Self);
 connected:=false;
 replay:=false;
 svern:=false;
 mymove:=true;
 LoadKeyboardLayout(RussianKeyboardLayout, KLF_ACTIVATE);
end;

procedure TForm1.ChessBrd1Capture(Sender: TObject; oldSq, newSq: Square;CapturedPiece: Char);
 const row='PNBRQpnbrq'; //   
 var p1,p2:byte;
 trig:boolean;
 i:cardinal;
begin
if byte(CapturedPiece)<90 then begin
 setlength(WhiteCaptured,length(WhiteCaptured)+1);
 WhiteCaptured[high(WhiteCaptured)]:=CapturedPiece;
end else begin
 setlength(BlackCaptured,length(BlackCaptured)+1);
 BlackCaptured[high(BlackCaptured)]:=CapturedPiece;
end;

 if length(BlackCaptured)>1 then repeat begin     // 
 trig:=true;
  for i:=0 to high(BlackCaptured)-1 do begin
  p1:=pos(BlackCaptured[i],row);
  p2:=pos(BlackCaptured[i+1],row);
   if p1>p2 then begin
   trig:=false;
   p1:=byte(BlackCaptured[i]);
   BlackCaptured[i]:=BlackCaptured[i+1];
   BlackCaptured[i+1]:=char(p1);
   end;
  end;
 end until trig;

 if length(WhiteCaptured)>1 then repeat begin      // 
 trig:=true;
  for i:=0 to high(WhiteCaptured)-1 do begin
  p1:=pos(WhiteCaptured[i],row);
  p2:=pos(WhiteCaptured[i+1],row);
   if p1>p2 then begin
   trig:=false;
   p1:=byte(WhiteCaptured[i]);
   WhiteCaptured[i]:=WhiteCaptured[i+1];
   WhiteCaptured[i+1]:=char(p1);
   end;
  end;
 end until trig;

Form1.Repaint;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
var
 buf:string;
 i:byte;
 trig:boolean;
begin
 trig:=true;
 buf:=Socket.ReceiveText;
 for i:=1 to length(id) do if id[i]<>buf[i] then trig:=false;
 if trig then begin
  ProBuf(buf);
 end else begin
  Memo2.Lines.Add(buf);
  mes:=true;
  SetToolTip;
 end;
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;Socket: TCustomWinSocket);
var
 buf:string;
 i:byte;
 trig:boolean;  
begin
 trig:=true;
 buf:=Socket.ReceiveText;
 for i:=1 to length(id) do if id[i]<>buf[i] then trig:=false;
if trig then begin
  ProBuf(buf);
 end else begin
  Memo2.Lines.Add(buf);
  mes:=true;
  SetToolTip;
 end;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
var
 buf:string;
 i:integer;
begin
 if (Key = VK_Return) then begin
  mes:=false;
  SetToolTip; 
  for i:=(Memo1.Lines.Count-MemoLine) downto 1 do buf:=buf+Memo1.Lines[Memo1.Lines.Count-i]+' ';
  MemoLine:=Memo1.Lines.Count;
  if connected then begin
   if IsServer then
    ServerSocket1.Socket.Connections[0].SendText(buf)
   else
    ClientSocket1.Socket.SendText(buf);
  end;  
 end;
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
begin
 form3.Top:=form1.Top+85;
 form3.left:=form1.left+92;
 form3.ShowModal;
end;

procedure TForm1.SaveAll(Filename: string);
 var Output,NByte,len:cardinal;
begin
 Output:=CreateFile(pchar(filename),GENERIC_WRITE,0,nil,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
 SetFilePointer(Output,0,nil,FILE_BEGIN);
  try
   WriteFile(Output,ver[1],length(ver),NByte,nil);

   WriteFile(Output,byte(ChessBrd1.WhiteOnTop),1,NByte,nil); // 1)  

   len:=length(game);
   WriteFile(Output,len,4,NByte,nil);
   WriteFile(Output,game[0],len,NByte,nil);

   SetEndOfFile(Output);
  finally
   closehandle(Output);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if saved=false then begin
  case messagebox(form1.Handle,'     ?','',MB_YESNOCANCEL or MB_ICONQUESTION) of
  idYES :   begin
            Action := caNone;
            ToolButton3.Click;
            exit;
           end;
  idcancel:begin
            Action := caNone;
            exit;
           end;
  end;
 end;
 UnregisterHotKey(form1.Handle,11);
 shell_notifyicon(nim_delete,@my);

 INIReg:=TRegInifile.Create;
 INIReg.WriteInteger(Key,'WinTop',form1.Top);
 INIReg.WriteInteger(Key,'WinLeft',form1.Left);
 INIReg.WriteInteger(Key,'Mode',radiogroup1.ItemIndex);
 INIReg.WriteString(Key,'Host',ComboBox2.Text);
 INIReg.WriteString(Key,'Port',edit2.Text);
 INIReg.WriteString(Key,'SaveDir',savedialog1.InitialDir);
 INIReg.WriteString(Key,'OpenDir',opendialog1.InitialDir);
 INIReg.WriteInteger(Key,'Pieces',combobox1.ItemIndex);
 if form1.WindowState=wsmaximized then
  INIReg.WriteBool(Key,'WinState',true) else
  INIReg.WriteBool(Key,'WinState',false);
 INIReg.WriteBool(Key,'Marks',ToolButton5.Down);
 INIReg.WriteBool(Key,'Tray',ToolButton7.Down);
 INIReg.CloseKey;
 INIReg.Free;
 ModPieces.Free;
 ServerSocket1.Active:=false;
 ClientSocket1.Active:=false;
 ServerSocket1.Close;
 ClientSocket1.Close;
 DestroyMenu(hm);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 if ComboBox1.ItemIndex=0 then Chessbrd1.CustomPieceSet:=nil
 else Chessbrd1.CustomPieceSet:=ModPieces;
 form1.Repaint;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48) and (byte(key)<>8)) or (byte(key)>57) then key:=#0;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 if serversocket1.Active then begin
  serversocket1.Active:=false;
  serversocket1.Port:=strtoint(edit2.Text);
  serversocket1.Active:=true;
 end;
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
 edit2.Enabled:=true;
 radiogroup1.Enabled:=true;
 connected:=false;
 ErrorCode:=0;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove; 
 RadioGroup1Click(self);
end;

procedure TForm1.ChessBrd1Mate(Sender: TObject; oldSq, newSq: Square);
begin
 messagebox(form1.Handle,'   !',' ...',mb_ok);
end;

procedure TForm1.FormPaint(Sender: TObject);
 var i:byte;
begin
 if length(BlackCaptured)>0 then for i:=0 to high(BlackCaptured) do
  chessbrd1.DrawChessPiece(form1.Canvas,4+i*40,520,BlackCaptured[i]);
 if length(WhiteCaptured)>0 then for i:=0 to high(WhiteCaptured) do
  chessbrd1.DrawChessPiece(form1.Canvas,4+i*40,480,WhiteCaptured[i]);
end;

procedure TForm1.UppendGame(x1, x2: square);
begin
 setlength(game,length(game)+2);
 game[high(game)-1]:=x1;
 game[high(game)]:=x2;
end;

procedure TForm1.LoadAll(Filename: string);
var
 Input,NByte,len:cardinal;
 Str:string;
 WOT:byte;
begin
 input:=CreateFile(pchar(filename),GENERIC_READ,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 SetFilePointer(input,0,nil,FILE_BEGIN);
 try
  setlength(str,length(ver));
  ReadFile(input,str[1],length(ver),NByte,nil);
  if str<>ver then begin
   messagebox(form1.Handle,'-  ...','...',mb_ok);
   opendialog1.FileName:='';
   exit;
  end;
  ChessBrd1.NewGame;
  listbox1.Clear;
  WhiteCaptured:=nil;
  BlackCaptured:=nil;
  form1.Repaint;
  Game:=nil;
  Promo:=nil;
  opendialog1.InitialDir:=ExtractFilePath(opendialog1.Filename);
  savedialog1.InitialDir:=opendialog1.InitialDir;
  opendialog1.FileName:=extractfilename(opendialog1.Filename);
  savedialog1.FileName:=opendialog1.FileName;

  form1.Caption:=' : '+savedialog1.InitialDir+'\'+savedialog1.FileName;

  ReadFile(input,WOT,1,NByte,nil);
  Chessbrd1.WhiteOnTop:=boolean(WOT);//   

  ReadFile(input,len,4,NByte,nil);
  setlength(game,len);
  ReadFile(input,game[0],len,NByte,nil);
 finally
  closehandle(input);
 end;
 toolbutton13.Click;
 saved:=true;
 mov:=false;
 SetToolTip;
end;

procedure TForm1.ChessBrd1LegalMove(Sender: TObject; oldSq, newSq: Square);
var
 list: TStringList;
begin
 if replay=false then begin
  if connected then
   if IsServer then
    ServerSocket1.Socket.Connections[0].SendText(id+'m'+char(oldsq)+char(newsq))
   else ClientSocket1.Socket.SendText(id+'m'+char(oldsq)+char(newsq));
  UppendGame(oldSq,newSq); //   
  if form1.Caption[length(form1.Caption)]<>'*' then form1.Caption:=form1.Caption+' *';
  saved:=false;
  mov:=false;
  SetToolTip;
  RecievedMove:=false;
 end;
 list:=TStringList.Create;
 Chessbrd1.GetMoveList(list);
 ListBox1.Items:=list;
 list.Free;
 ListBox1.Selected[ListBox1.Count-1]:=true;
 if (MyMove=true) and connected then MyMove:=false;  //         ,    
 ChessBrd1.Enabled:=MyMove;
end;

procedure TForm1.ReplayGame;
var
 i:cardinal;
begin
 if game<>nil then begin
   promo:=nil;
   for i:=0 to high(game) do begin
    if byte(game[i])=0 then begin
     setlength(promo,length(promo)+1);
     promo[high(promo)]:=char(game[i+1]);
    end;
   end;
  replay:=true;
  toolbar1.Enabled:=false;
  ChessBrd1.Enabled:=false;
  ChessBrd1.AnimateMoves:=false;
   for i:=0 to (high(game) div 2) do
    if game[i*2]<>none then ChessBrd1.Move(game[i*2],game[i*2+1]);
  ChessBrd1.AnimateMoves:=true;
  replay:=false;
  ChessBrd1.Enabled:=true;
  toolbar1.Enabled:=true;
 end else begin // 
  if connected then begin //     
   if IsServer then
    ServerSocket1.Socket.Connections[0].SendText(id+'n'+char(byte(not Chessbrd1.WhiteOnTop)))
   else
    ClientSocket1.Socket.SendText(id+'n'+char(byte(not Chessbrd1.WhiteOnTop)));
  end;
 end;
 mov:=false;
 SetToolTip;
end;

procedure TForm1.ProBuf(buf: string);
var
 m1,m2:Square;
 cod:char;
 i:integer;
begin
 cod:=(buf[length(id)+1]);
 case byte(cod) of
 byte('m'):begin // 'm' - simple move
           replay:=true;
           m1:=Square(buf[length(id)+2]);
           m2:=Square(buf[length(id)+3]);
           RecievedMove:=true;
           ChessBrd1.Move(m1,m2);
           UppendGame(m1,m2); //   
           mov:=true;
           SetToolTip;
           if form1.Caption[length(form1.Caption)]<>'*' then form1.Caption:=form1.Caption+' *';
           saved:=false;
           replay:=false;
           RecievedMove:=false;
           MyMove:=true;
           ChessBrd1.Enabled:=MyMove;
           end;
 byte('p'):begin // 'p' - promotion
           form2.Button1.Enabled:=true;
           form2.RadioGroup1.ItemIndex:=byte(buf[length(id)+2]);
           form2.Button1.Click;
           end;
 byte('n'):begin  // new game by net
           ChessBrd1.NewGame;
           listbox1.Clear;
           WhiteCaptured:=nil;
           BlackCaptured:=nil;
           form1.Repaint;
           chessbrd1.Enabled:=false;
           game:=nil;
           promo:=nil;
           Chessbrd1.WhiteOnTop:=boolean(byte(buf[length(buf)]));
           setlength(game,length(buf)-length(id)-2);
           if game<>nil then begin
            for i:=length(id)+2 to length(buf)-1 do game[i-length(id)-2]:=square(buf[i]);
            ReplayGame;
           end;
           chessbrd1.Enabled:=true;
           saved:=true;
           savedialog1.fileName:='';
           MyMove:=true;
           ChessBrd1.Enabled:=MyMove;
           form1.Caption:=' ';
           end;
 end;
end;

procedure TForm1.ToolButton13Click(Sender: TObject);
var buf:array of char;
 i:cardinal;
begin
 if game<>nil then begin
  setlength(buf,length(game));
  for i:=0 to high(game) do buf[i]:=char(game[i]);
  if connected then begin //     
   if IsServer then
    ServerSocket1.Socket.Connections[0].SendText(id+'n'+string(buf)+char(byte(not Chessbrd1.WhiteOnTop)))
   else
    ClientSocket1.Socket.SendText(id+'n'+string(buf)+char(byte(not Chessbrd1.WhiteOnTop)));
  end;
 end;
 ChessBrd1.NewGame;
 listbox1.Clear;
 WhiteCaptured:=nil;
 BlackCaptured:=nil;
 form1.Repaint;
 ReplayGame;
 MyMove:=true;
 ChessBrd1.Enabled:=MyMove;
end;

procedure TForm1.ChessBrd1ThreefoldPosition(Sender: TObject);
begin
 messagebox(form1.Handle,'...',' ',mb_ok);
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if (Key=VK_Return) then memo1.Lines.Strings[memoline]:='> ';
end;

procedure TForm1.ToolButton3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var filname:string;
begin
 if button=mbRight then begin
  if savedialog1.Execute then
   if savedialog1.FileName<>'' then begin
    filname:=ChangeFileExt(savedialog1.FileName,'')+'.chd';
    if FileExists(filname) then
     case messagebox(form1.Handle,'      .'+
     #13#10+#13#10+'  ?','',MB_YESNO or MB_ICONQUESTION) of
     idYES: ToolButton3.Click;
     idNO: ToolButton3MouseDown(nil, mbRight, Shift, X, Y);
     end;
   end;
 end;
end;

procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
begin
 if (msg.message = wm_keydown) then begin
  if (MSG.wParam=27) then begin  //esc
   form3.Close;
   if toolbutton7.Down then
    postmessage(form1.Handle,My_MES,0,WM_LBUTTONDBLCLK)
   else begin
    application.Minimize;
    svern:=true;
   end;
   exit;
  end;
  if (MSG.wParam=83) and (prevbut=17) then begin toolbutton3.Click; Handled:=true; end;
  prevbut:=MSG.wParam;
 end;
end;

procedure TForm1.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
 if byte(key)=vk_return then Button2Click(self);
end;

procedure TForm1.ComboBox2Select(Sender: TObject);
 var i:cardinal;
begin
 for i:=0 to high(hist) do if hist[i].host=ComboBox2.Text then edit2.Text:=hist[i].port;
end;

procedure TForm1.ComboBox2Enter(Sender: TObject);
begin
 LoadKeyboardLayout(EngKeyboardLayout, KLF_ACTIVATE);
end;

procedure TForm1.Memo1Enter(Sender: TObject);
begin
 LoadKeyboardLayout(RussianKeyboardLayout, KLF_ACTIVATE);
end;

procedure TForm1.ChessBrd1StaleMate(Sender: TObject; oldSq, newSq: Square);
begin
 messagebox(form1.Handle,' , ... ',' ',mb_ok);
end;

procedure TForm1.ToolButton5Click(Sender: TObject);
var
 cset: CoordSet;
begin
if ToolButton5.Down then
  begin
    Include(cset,North);
    Include(cset,East);
    Include(cset,West);
    Include(cset,South);
  end else begin
    Exclude(cset,North);
    Exclude(cset,East);
    Exclude(cset,West);
    Exclude(cset,South);
  end;
  Chessbrd1.DisplayCoords:=cset;
end;

procedure TForm1.ControlWindow(var Msg: TMessage);
begin
 if (Msg.WParam=SC_MINIMIZE)or(Msg.WParam=SC_CLOSE) then begin
  postmessage(form1.Handle,My_MES,0,WM_LBUTTONDBLCLK);
 end else inherited;
end;

procedure TForm1.TrayControl(var Msg: TMessage);
begin
 case LOWORD(Msg.wParam) of
  100:postmessage(form1.Handle,MY_MES,0,WM_LBUTTONDBLCLK); //
  0:form1.Close;
 else inherited;
 end;
end;

procedure TForm1.WMGetTrayMes(var Msg: TMessage);
 var t:tpoint;
begin
 case Msg.LParam of
 WM_LBUTTONDOWN: if svern=false then begin
  ShowWindow(Form1.Handle,SW_SHOW);
  application.Restore;
  form1.BringToFront;
  SetWindowPos(form1.Handle,HWND_TOP,form1.Left,form1.Top,form1.Width,form1.Height,SWP_SHOWWINDOW);
  BringWindowToTop(form1.Handle);
  SetForegroundWindow(form1.Handle);
  SetActiveWindow(form1.Handle);
 end;
 WM_LBUTTONDBLCLK: if svern=false then begin   // 
  if ToolButton7.Down then begin
   ShowWindow(Handle,SW_HIDE);
   svern:=true;   //   
   ModifyMenu(hm,100,MF_BYCOMMAND or MF_STRING,100,'')
  end else begin
   application.Minimize;
  end;
 end else begin                                // 
  ShowWindow(Form1.Handle,SW_SHOW);
  application.Restore;
  form1.BringToFront;
  SetWindowPos(form1.Handle,HWND_TOP,form1.Left,form1.Top,form1.Width,form1.Height,SWP_SHOWWINDOW);
  BringWindowToTop(form1.Handle);
  SetForegroundWindow(form1.Handle);
  SetActiveWindow(form1.Handle);
  svern:=false; //   
  ModifyMenu(hm,100,MF_BYCOMMAND or MF_STRING,100,'')
 end;
 WM_RBUTTONUP: begin
  getcursorpos(t);
  SetForegroundWindow(form1.Handle);
  TrackPopupMenuEx(hm,TPM_BOTTOMALIGN or TPM_RIGHTALIGN or TPM_RIGHTBUTTON or TPM_LEFTBUTTON,t.X,t.Y,form1.Handle,nil);
  PostMessage(form1.Handle,WM_NULL,0,0);
 end;
 end;
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
 if ToolButton7.Down then begin
  ShowWindow(Application.Handle,sw_hide);
  shell_notifyicon(nim_add,@my);
 end else begin
  ShowWindow(Application.Handle,sw_show);
  shell_notifyicon(nim_delete,@my);
 end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 if ToolButton7.Tag=1 then begin  // Tag=1   
  ToolButton7.Tag:=0;
  ToolButton7Click(nil);
 end;
end;

procedure TForm1.SetToolTip;
 var m,l:integer;
 s1,s2:string;
begin
  if (mov and mes)=true then begin
   application.Title:='  ';
   s1:='  ';
   s2:='MOVMES';
  end;
  if (mov and mes)=false then begin
   application.Title:=' ';
   s1:=' ';
   s2:='MAIN';
  end;
  if mes and (mov=false) then begin
   application.Title:=' ';
   s1:='';
   s2:='MES';
  end;
  if mov and (mes=false) then begin
   application.Title:=' ';
   s1:='';
   s2:='MOV';
  end;
  my.hIcon:=loadicon(hinstance,pchar(s2));

  L:=length(s1);
  for m:=1 to L do
  my.szTip[m-1]:=s1[m];
  my.szTip[l]:=#0;

  shell_notifyicon(NIM_MODIFY,@my);
end;

procedure TForm1.HotKey(var Msg: TMessage);
begin
 if toolbutton7.Down then
  postmessage(form1.Handle,My_MES,0,WM_LBUTTONDBLCLK)
 else begin
  if svern then application.Restore else
  application.Minimize;
  svern:=not(svern);
 end;
end;

procedure TForm1.ApplicationEvents1Activate(Sender: TObject);
begin
 mes:=false;
 SetToolTip;
end;

end.
